igeo

## Class IBoidGeo

- java.lang.Object
- - igeo.IDynamicsBase
  - - igeo.IParticleGeo
    - - igeo.IBoidGeo

- All Implemented Interfaces:
    IArithmeticVal<IVecI,IDoubleI>, IBoidI, IDynamics, IParameter, IParticleI, ISubobject, ITransformable, IVal, IVecI, IVecOp

      public class IBoidGeo
      extends IParticleGeo
      implements IBoidI

  Class of boid algorithm (swarm algorithm).
  Author:
    Satoru Sugihara

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `double` | `alignmentDist`
    `(package private) IVec` | `alignmentForce`
    `double` | `alignmentLimit`
    `double` | `alignmentRatio`
    `double` | `cohesionDist`
    `(package private) IVec` | `cohesionForce`
    `double` | `cohesionLimit`
    `double` | `cohesionRatio`
    `double` | `separationDist`
    `(package private) IVec` | `separationForce`
    `double` | `separationLimit`
    `double` | `separationRatio`
    `java.util.ArrayList<java.lang.Class<? extends IBoidI>>` | `targetClasses`

    - ### Fields inherited from class igeo.IParticleGeo

      `defaultFriction, fixed, frc, friction, mass, pos, skipUpdateOnce, vel`

    - ### Fields inherited from class igeo.IDynamicsBase

      `parent, targets`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IBoidGeo()`
    `IBoidGeo(double x, double y, double z)`
    `IBoidGeo(double x, double y, double z, double vx, double vy, double vz)`
    `IBoidGeo(IBoidGeo b)`
    `IBoidGeo(IVec pt)`
    `IBoidGeo(IVecI pt)`
    `IBoidGeo(IVecI pt, IVecI vel)`
    `IBoidGeo(IVec pt, IVec vel)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `IBoidGeo` | `add(double x, double y, double z)`
    `IBoidGeo` | `add(double f, IVecI v)` scale add
    `IBoidGeo` | `add(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IBoidGeo` | `add(IDoubleI f, IVecI v)` scale add
    `IBoidGeo` | `add(IVecI v)`
    `IBoidGeo` | `add(IVecI v, double f)` scale add
    `IBoidGeo` | `add(IVecI v, IDoubleI f)` scale add
    `IBoidGeo` | `addForce(double fx, double fy, double fz)` adding force (alias of push)
    `IBoidGeo` | `addForce(IVecI f)` adding force (alias of push)
    `IBoidGeo` | `ali(double ratio, double dist)`
    `double` | `aliDist()`
    `IBoidGeo` | `aliDist(double dist)`
    `IBoidGeo` | `alignment(double ratio, double dist)`
    `double` | `alignmentDist()`
    `IBoidGeo` | `alignmentDist(double dist)`
    `double` | `alignmentLimit()`
    `IBoidGeo` | `alignmentLimit(double limit)`
    `double` | `alignmentRatio()`
    `IBoidGeo` | `alignmentRatio(double ratio)`
    `double` | `aliLimit()`
    `IBoidGeo` | `aliLimit(double limit)`
    `double` | `aliRatio()`
    `IBoidGeo` | `aliRatio(double ratio)`
    `IBoidGeo` | `coh(double ratio, double dist)`
    `double` | `cohDist()`
    `IBoidGeo` | `cohDist(double dist)`
    `IBoidGeo` | `cohesion(double ratio, double dist)`
    `double` | `cohesionDist()`
    `IBoidGeo` | `cohesionDist(double dist)`
    `double` | `cohesionLimit()`
    `IBoidGeo` | `cohesionLimit(double limit)`
    `double` | `cohesionRatio()`
    `IBoidGeo` | `cohesionRatio(double ratio)`
    `double` | `cohLimit()`
    `IBoidGeo` | `cohLimit(double limit)`
    `double` | `cohRatio()`
    `IBoidGeo` | `cohRatio(double ratio)`
    `IBoidGeo` | `cp()` cp() is alias of dup()
    `IBoidGeo` | `cp(double x, double y, double z)` cp() is alias of dup().add()
    `IBoidGeo` | `cp(IDoubleI x, IDoubleI y, IDoubleI z)` cp() is alias of dup().add()
    `IBoidGeo` | `cp(IVecI v)` cp() is alias of dup().add()
    `IBoidGeo` | `decay(double d)`
    `IBoidGeo` | `div(double v)`
    `IBoidGeo` | `div(IDoubleI v)`
    `IBoidGeo` | `dup()` duplicate the instance
    `IBoidGeo` | `fix()` IParticleI API
    `IBoidGeo` | `flip()` alias of neg()
    `IBoidGeo` | `force(IVecI v)` set force
    `IBoidGeo` | `frc(IVecI v)` set force
    `IBoidGeo` | `fric(double friction)` set friction
    `IBoidGeo` | `friction(double friction)` set friction
    `void` | `initBoid()`
    `void` | `interact(java.util.ArrayList<IDynamics> dynamics)` behavior definition of interaction with other dynamic objects.
    `boolean` | `isTarget(java.lang.Object obj)` alias
    `boolean` | `isTargetClass(java.lang.Object obj)`
    `IBoidGeo` | `len(double l)` setting length
    `IBoidGeo` | `len(IDoubleI l)` setting length
    `IBoidGeo` | `mass(double mass)` set mass
    `IBoidGeo` | `mirror(double planeX, double planeY, double planeZ)` reflect (mirror) 3 dimensionally to the other side of the plane
    `IBoidGeo` | `mirror(double centerX, double centerY, double centerZ, double planeX, double planeY, double planeZ)` reflect (mirror) 3 dimensionally to the other side of the plane
    `IBoidGeo` | `mirror(IVecI planeDir)` reflect (mirror) 3 dimensionally to the other side of the plane
    `IBoidGeo` | `mirror(IVecI center, IVecI planeDir)` reflect (mirror) 3 dimensionally to the other side of the plane
    `IBoidGeo` | `mul(double v)`
    `IBoidGeo` | `mul(IDoubleI v)`
    `IBoidGeo` | `mv(double x, double y, double z)` mv() is alias of add()
    `IBoidGeo` | `mv(IDoubleI x, IDoubleI y, IDoubleI z)` mv() is alias of add()
    `IBoidGeo` | `mv(IVecI v)` mv() is alias of add()
    `IBoidGeo` | `neg()`
    `IBoidGeo` | `param(double cohRatio, double cohDist, double sepRatio, double sepDist, double aliRatio, double aliDist)`
    `IBoidGeo` | `parameter(double cohRatio, double cohDist, double sepRatio, double sepDist, double aliRatio, double aliDist)`
    `IBoidGeo` | `pos(IVecI v)` set position
    `IBoidGeo` | `position(IVecI v)` set position
    `IBoidGeo` | `pull(double fx, double fy, double fz)` adding negative force
    `IBoidGeo` | `pull(IVecI f)` adding negative force
    `IBoidGeo` | `push(double fx, double fy, double fz)` adding force
    `IBoidGeo` | `push(IVecI f)` adding force
    `IBoidGeo` | `ref(double planeX, double planeY, double planeZ)` reflect (mirror) 3 dimensionally to the other side of the plane
    `IBoidGeo` | `ref(double centerX, double centerY, double centerZ, double planeX, double planeY, double planeZ)` reflect (mirror) 3 dimensionally to the other side of the plane
    `IBoidGeo` | `ref(IVecI planeDir)` reflect (mirror) 3 dimensionally to the other side of the plane
    `IBoidGeo` | `ref(IVecI center, IVecI planeDir)` reflect (mirror) 3 dimensionally to the other side of the plane
    `IBoidGeo` | `reset()` setting force zero
    `IBoidGeo` | `resetForce()` setting force zero (alias of reset())
    `IBoidGeo` | `rev()` alias of neg()
    `IBoidGeo` | `rot(double angle)` rotation on XY plane
    `IBoidGeo` | `rot(double axisX, double axisY, double axisZ, double angle)` rotation around axis vector
    `IBoidGeo` | `rot(double centerX, double centerY, double centerZ, double axisX, double axisY, double axisZ, double angle)` rotation around axis vector and center point
    `IBoidGeo` | `rot(IDoubleI angle)` rotation on XY plane
    `IBoidGeo` | `rot(IVecI axis, double angle)` rotation around axis vector
    `IBoidGeo` | `rot(IVecI axis, IDoubleI angle)` rotation around axis vector
    `IBoidGeo` | `rot(IVecI axis, IVecI destDir)` Rotate to destination direction vector.
    `IBoidGeo` | `rot(IVecI center, IVecI axis, double angle)` rotation around axis vector and center point
    `IBoidGeo` | `rot(IVecI center, IVecI axis, IDoubleI angle)` rotation around axis vector and center point
    `IBoidGeo` | `rot(IVecI center, IVecI axis, IVecI destPt)` Rotate to destination point location.
    `IBoidGeo` | `rot2(double angle)` rotation on xy-plane; alias of rot(double)
    `IBoidGeo` | `rot2(double centerX, double centerY, double angle)` rotation on xy-plane
    `IBoidGeo` | `rot2(IDoubleI angle)` rotation on xy-plane; alias of rot(IDoubleI)
    `IBoidGeo` | `rot2(IVecI destDir)` rotation on xy-plane towards destDir
    `IBoidGeo` | `rot2(IVecI center, double angle)` rotation on xy-plane
    `IBoidGeo` | `rot2(IVecI center, IDoubleI angle)` rotation on xy-plane
    `IBoidGeo` | `rot2(IVecI center, IVecI destPt)` rotation on xy-plane towards destPt
    `IBoidGeo` | `scale(double f)` alias of mul
    `IBoidGeo` | `scale(double centerX, double centerY, double centerZ, double f)` scale from a center
    `IBoidGeo` | `scale(IDoubleI f)` alias of mul
    `IBoidGeo` | `scale(IVecI center, double f)` scale from a center
    `IBoidGeo` | `scale(IVecI center, IDoubleI f)` scale from a center
    `IBoidGeo` | `scale1d(double axisX, double axisY, double axisZ, double f)` scale only in 1 direction
    `IBoidGeo` | `scale1d(double centerX, double centerY, double centerZ, double axisX, double axisY, double axisZ, double f)` scale only in 1 direction from a center
    `IBoidGeo` | `scale1d(IVecI axis, double f)` scale only in 1 direction
    `IBoidGeo` | `scale1d(IVecI axis, IDoubleI f)` scale only in 1 direction
    `IBoidGeo` | `scale1d(IVecI center, IVecI axis, double f)` scale only in 1 direction from a center
    `IBoidGeo` | `scale1d(IVecI center, IVecI axis, IDoubleI f)` scale only in 1 direction from a center
    `IBoidGeo` | `sep(double ratio, double dist)`
    `IBoidGeo` | `separation(double ratio, double dist)`
    `double` | `separationDist()`
    `IBoidGeo` | `separationDist(double dist)`
    `double` | `separationLimit()`
    `IBoidGeo` | `separationLimit(double limit)`
    `double` | `separationRatio()`
    `IBoidGeo` | `separationRatio(double ratio)`
    `double` | `sepDist()`
    `IBoidGeo` | `sepDist(double dist)`
    `double` | `sepLimit()`
    `IBoidGeo` | `sepLimit(double limit)`
    `double` | `sepRatio()`
    `IBoidGeo` | `sepRatio(double ratio)`
    `IBoidGeo` | `set(double x, double y, double z)`
    `IBoidGeo` | `set(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IBoidGeo` | `set(IVecI v)`
    `IBoidGeo` | `shear(double sxy, double syx, double syz, double szy, double szx, double sxz)` shear operation
    `IBoidGeo` | `shear(IDoubleI sxy, IDoubleI syx, IDoubleI syz, IDoubleI szy, IDoubleI szx, IDoubleI sxz)` shear operation
    `IBoidGeo` | `shear(IVecI center, double sxy, double syx, double syz, double szy, double szx, double sxz)` shear operation
    `IBoidGeo` | `shear(IVecI center, IDoubleI sxy, IDoubleI syx, IDoubleI syz, IDoubleI szy, IDoubleI szx, IDoubleI sxz)` shear operation
    `IBoidGeo` | `shearXY(double sxy, double syx)` shear operation on XY
    `IBoidGeo` | `shearXY(IDoubleI sxy, IDoubleI syx)` shear operation on XY
    `IBoidGeo` | `shearXY(IVecI center, double sxy, double syx)` shear operation on XY
    `IBoidGeo` | `shearXY(IVecI center, IDoubleI sxy, IDoubleI syx)` shear operation on XY
    `IBoidGeo` | `shearYZ(double syz, double szy)` shear operation on YZ
    `IBoidGeo` | `shearYZ(IDoubleI syz, IDoubleI szy)` shear operation on YZ
    `IBoidGeo` | `shearYZ(IVecI center, double syz, double szy)` shear operation on YZ
    `IBoidGeo` | `shearYZ(IVecI center, IDoubleI syz, IDoubleI szy)` shear operation on YZ
    `IBoidGeo` | `shearZX(double szx, double sxz)` shear operation on ZX
    `IBoidGeo` | `shearZX(IDoubleI szx, IDoubleI sxz)` shear operation on ZX
    `IBoidGeo` | `shearZX(IVecI center, double szx, double sxz)` shear operation on ZX
    `IBoidGeo` | `shearZX(IVecI center, IDoubleI szx, IDoubleI sxz)` shear operation on ZX
    `IBoidGeo` | `skipUpdateOnce(boolean f)` for other agent to control particle
    `IBoidGeo` | `sub(double x, double y, double z)`
    `IBoidGeo` | `sub(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IBoidGeo` | `sub(IVecI v)`
    `IBoidGeo` | `target(java.lang.Class<? extends IBoidI>... targets)` alias
    `IBoidGeo` | `target(java.lang.Class<? extends IBoidI> targetClass)` alias
    `IBoidGeo` | `targetClass(java.lang.Class<? extends IBoidI>... targets)` make the field applicable only to the specified target classes
    `IBoidGeo` | `targetClass(java.lang.Class<? extends IBoidI> targetClass)` make the field applicable only to the specified target class
    `IBoidGeo` | `transform(IMatrix3I mat)` transform with a transformation matrix
    `IBoidGeo` | `transform(IMatrix4I mat)` transform with a transformation matrix
    `IBoidGeo` | `transform(IVecI xvec, IVecI yvec, IVecI zvec)` transform with a transformation vectors
    `IBoidGeo` | `transform(IVecI xvec, IVecI yvec, IVecI zvec, IVecI translate)` transform with a transformation vectors
    `IBoidGeo` | `translate(double x, double y, double z)` translate is alias of add()
    `IBoidGeo` | `translate(IDoubleI x, IDoubleI y, IDoubleI z)` alias of add()
    `IBoidGeo` | `translate(IVecI v)` alias of add()
    `IBoidGeo` | `unfix()` unfix movement
    `IBoidGeo` | `unit()` unitize
    `IBoidGeo` | `vel(IVecI v)` set velocity
    `IBoidGeo` | `velocity(IVecI v)` set velocity
    `IBoidGeo` | `x(double vx)` methods of IVecI
    `IBoidGeo` | `x(IDoubleI vx)` setting x component
    `IBoidGeo` | `x(IVec2I v)` setting x component by x component of input vector
    `IBoidGeo` | `x(IVecI v)` setting x component by x component of input vector
    `IBoidGeo` | `y(double vy)` setting y component
    `IBoidGeo` | `y(IDoubleI vy)` setting y component
    `IBoidGeo` | `y(IVec2I v)` setting y component by y component of input vector
    `IBoidGeo` | `y(IVecI v)` setting y component by y component of input vector
    `IBoidGeo` | `z(double vz)` setting z component
    `IBoidGeo` | `z(IDoubleI vz)` setting z component
    `IBoidGeo` | `z(IVecI v)` setting z component by z component of input vector
    `IBoidGeo` | `zero()` setting all zero

    - ### Methods inherited from class igeo.IParticleGeo

      `acc, acceleration, angle, angle, angle, angle, angle, angle, angle, angle, bisect, bisect, cross, cross, decay, dif, dif, diff, diff, dist, dist, dist, dist, dist2, dist2, dist2, dist2, dot, dot, dot, dot, eq, eq, eq, eq, eq, eq, eq, eq, eqX, eqX, eqX, eqX, eqX, eqX, eqX, eqX, eqY, eqY, eqY, eqY, eqY, eqY, eqY, eqY, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, fixed, force, frc, fric, friction, get, getX, getY, getZ, initParticle, initParticle, initParticle, isValid, len, len, len, len2, len2, len2, mass, mid, mid, nml, nml, nml, nml, pos, position, postupdate, preupdate, removeTarget, removeTarget, skipUpdateOnce, sum, sum, sum, sum, sum, sum, sum, target, to2d, to2d, to2d, to2d, to4d, to4d, to4d, toString, update, vel, velocity, x, x, x, y, y, y, z, z, z`

    - ### Methods inherited from class igeo.IDynamicsBase

      `initDynamicsBase, initDynamicsBase, initDynamicsBase, localDynamics, parent, parent, postinteract, preinteract, target, targetNum, targets, updateTarget`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface igeo.IParticleI

      `acc, acceleration, decay, fixed, force, frc, fric, friction, mass, pos, position, removeTarget, removeTarget, skipUpdateOnce, target, target, targetNum, targets, updateTarget, vel, velocity`

    - ### Methods inherited from interface igeo.IVecI

      `angle, angle, angle, angle, angle, angle, angle, angle, bisect, bisect, cross, cross, dif, dif, diff, diff, dist, dist, dist, dist, dist2, dist2, dist2, dist2, dot, dot, dot, dot, eq, eq, eq, eq, eq, eq, eq, eq, eqX, eqX, eqX, eqX, eqX, eqX, eqX, eqX, eqY, eqY, eqY, eqY, eqY, eqY, eqY, eqY, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, get, getX, getY, getZ, isValid, len, len, len, len2, len2, len2, mid, mid, nml, nml, nml, nml, sum, sum, sum, sum, sum, sum, sum, to2d, to2d, to2d, to2d, to4d, to4d, to4d, x, x, x, y, y, y, z, z, z`

- - ### Field Detail

    - #### cohesionDist

          public double cohesionDist

    - #### cohesionRatio

          public double cohesionRatio

    - #### cohesionLimit

          public double cohesionLimit

    - #### separationDist

          public double separationDist

    - #### separationRatio

          public double separationRatio

    - #### separationLimit

          public double separationLimit

    - #### alignmentDist

          public double alignmentDist

    - #### alignmentRatio

          public double alignmentRatio

    - #### alignmentLimit

          public double alignmentLimit

    - #### cohesionForce

          IVec cohesionForce

    - #### separationForce

          IVec separationForce

    - #### alignmentForce

          IVec alignmentForce

    - #### targetClasses

          public java.util.ArrayList<java.lang.Class<? extends IBoidI>> targetClasses

  - ### Constructor Detail

    - #### IBoidGeo

          public IBoidGeo()

    - #### IBoidGeo

          public IBoidGeo(IVecI pt)

    - #### IBoidGeo

          public IBoidGeo(IVec pt)

    - #### IBoidGeo

          public IBoidGeo(IVecI pt,
                  IVecI vel)

    - #### IBoidGeo

          public IBoidGeo(IVec pt,
                  IVec vel)

    - #### IBoidGeo

          public IBoidGeo(double x,
                  double y,
                  double z)

    - #### IBoidGeo

          public IBoidGeo(double x,
                  double y,
                  double z,
                  double vx,
                  double vy,
                  double vz)

    - #### IBoidGeo

          public IBoidGeo(IBoidGeo b)

  - ### Method Detail

    - #### initBoid

          public void initBoid()

    - #### cohDist

          public double cohDist()

      Specified by:
        `cohDist` in interface `IBoidI`

    - #### cohesionDist

          public double cohesionDist()

      Specified by:
        `cohesionDist` in interface `IBoidI`

    - #### cohDist

          public IBoidGeo cohDist(double dist)

      Specified by:
        `cohDist` in interface `IBoidI`

    - #### cohesionDist

          public IBoidGeo cohesionDist(double dist)

      Specified by:
        `cohesionDist` in interface `IBoidI`

    - #### cohRatio

          public double cohRatio()

      Specified by:
        `cohRatio` in interface `IBoidI`

    - #### cohesionRatio

          public double cohesionRatio()

      Specified by:
        `cohesionRatio` in interface `IBoidI`

    - #### cohRatio

          public IBoidGeo cohRatio(double ratio)

      Specified by:
        `cohRatio` in interface `IBoidI`

    - #### cohesionRatio

          public IBoidGeo cohesionRatio(double ratio)

      Specified by:
        `cohesionRatio` in interface `IBoidI`

    - #### cohLimit

          public double cohLimit()

      Specified by:
        `cohLimit` in interface `IBoidI`

    - #### cohesionLimit

          public double cohesionLimit()

      Specified by:
        `cohesionLimit` in interface `IBoidI`

    - #### cohLimit

          public IBoidGeo cohLimit(double limit)

      Specified by:
        `cohLimit` in interface `IBoidI`

    - #### cohesionLimit

          public IBoidGeo cohesionLimit(double limit)

      Specified by:
        `cohesionLimit` in interface `IBoidI`

    - #### coh

          public IBoidGeo coh(double ratio,
                     double dist)

      Specified by:
        `coh` in interface `IBoidI`

    - #### cohesion

          public IBoidGeo cohesion(double ratio,
                          double dist)

      Specified by:
        `cohesion` in interface `IBoidI`

    - #### sepDist

          public double sepDist()

      Specified by:
        `sepDist` in interface `IBoidI`

    - #### separationDist

          public double separationDist()

      Specified by:
        `separationDist` in interface `IBoidI`

    - #### sepDist

          public IBoidGeo sepDist(double dist)

      Specified by:
        `sepDist` in interface `IBoidI`

    - #### separationDist

          public IBoidGeo separationDist(double dist)

      Specified by:
        `separationDist` in interface `IBoidI`

    - #### sepRatio

          public double sepRatio()

      Specified by:
        `sepRatio` in interface `IBoidI`

    - #### separationRatio

          public double separationRatio()

      Specified by:
        `separationRatio` in interface `IBoidI`

    - #### sepRatio

          public IBoidGeo sepRatio(double ratio)

      Specified by:
        `sepRatio` in interface `IBoidI`

    - #### separationRatio

          public IBoidGeo separationRatio(double ratio)

      Specified by:
        `separationRatio` in interface `IBoidI`

    - #### sepLimit

          public double sepLimit()

      Specified by:
        `sepLimit` in interface `IBoidI`

    - #### separationLimit

          public double separationLimit()

      Specified by:
        `separationLimit` in interface `IBoidI`

    - #### sepLimit

          public IBoidGeo sepLimit(double limit)

      Specified by:
        `sepLimit` in interface `IBoidI`

    - #### separationLimit

          public IBoidGeo separationLimit(double limit)

      Specified by:
        `separationLimit` in interface `IBoidI`

    - #### sep

          public IBoidGeo sep(double ratio,
                     double dist)

      Specified by:
        `sep` in interface `IBoidI`

    - #### separation

          public IBoidGeo separation(double ratio,
                            double dist)

      Specified by:
        `separation` in interface `IBoidI`

    - #### aliDist

          public double aliDist()

      Specified by:
        `aliDist` in interface `IBoidI`

    - #### alignmentDist

          public double alignmentDist()

      Specified by:
        `alignmentDist` in interface `IBoidI`

    - #### aliDist

          public IBoidGeo aliDist(double dist)

      Specified by:
        `aliDist` in interface `IBoidI`

    - #### alignmentDist

          public IBoidGeo alignmentDist(double dist)

      Specified by:
        `alignmentDist` in interface `IBoidI`

    - #### aliRatio

          public double aliRatio()

      Specified by:
        `aliRatio` in interface `IBoidI`

    - #### alignmentRatio

          public double alignmentRatio()

      Specified by:
        `alignmentRatio` in interface `IBoidI`

    - #### aliRatio

          public IBoidGeo aliRatio(double ratio)

      Specified by:
        `aliRatio` in interface `IBoidI`

    - #### alignmentRatio

          public IBoidGeo alignmentRatio(double ratio)

      Specified by:
        `alignmentRatio` in interface `IBoidI`

    - #### aliLimit

          public double aliLimit()

      Specified by:
        `aliLimit` in interface `IBoidI`

    - #### alignmentLimit

          public double alignmentLimit()

      Specified by:
        `alignmentLimit` in interface `IBoidI`

    - #### aliLimit

          public IBoidGeo aliLimit(double limit)

      Specified by:
        `aliLimit` in interface `IBoidI`

    - #### alignmentLimit

          public IBoidGeo alignmentLimit(double limit)

      Specified by:
        `alignmentLimit` in interface `IBoidI`

    - #### ali

          public IBoidGeo ali(double ratio,
                     double dist)

      Specified by:
        `ali` in interface `IBoidI`

    - #### alignment

          public IBoidGeo alignment(double ratio,
                           double dist)

      Specified by:
        `alignment` in interface `IBoidI`

    - #### parameter

          public IBoidGeo parameter(double cohRatio,
                           double cohDist,
                           double sepRatio,
                           double sepDist,
                           double aliRatio,
                           double aliDist)

      Specified by:
        `parameter` in interface `IBoidI`

    - #### param

          public IBoidGeo param(double cohRatio,
                       double cohDist,
                       double sepRatio,
                       double sepDist,
                       double aliRatio,
                       double aliDist)

      Specified by:
        `param` in interface `IBoidI`

    - #### targetClass

          public IBoidGeo targetClass(java.lang.Class<? extends IBoidI> targetClass)

      make the field applicable only to the specified target class

    - #### target

          public IBoidGeo target(java.lang.Class<? extends IBoidI> targetClass)

      alias

    - #### targetClass

          public IBoidGeo targetClass(java.lang.Class<? extends IBoidI>... targets)

      make the field applicable only to the specified target classes

    - #### target

          public IBoidGeo target(java.lang.Class<? extends IBoidI>... targets)

      alias

    - #### isTargetClass

          public boolean isTargetClass(java.lang.Object obj)

    - #### isTarget

          public boolean isTarget(java.lang.Object obj)

      alias

    - #### interact

          public void interact(java.util.ArrayList<IDynamics> dynamics)

      Description copied from class: `IDynamicsBase`
      behavior definition of interaction with other dynamic objects. The server puts all dynamic objects including itself.
      Specified by:
        `interact` in interface `IDynamics`
      Overrides:
        `interact` in class `IDynamicsBase`

    - #### fix

          public IBoidGeo fix()

      IParticleI API
      Specified by:
        `fix` in interface `IParticleI`
      Overrides:
        `fix` in class `IParticleGeo`

    - #### unfix

          public IBoidGeo unfix()

      Description copied from interface: `IParticleI`
      unfix movement
      Specified by:
        `unfix` in interface `IParticleI`
      Overrides:
        `unfix` in class `IParticleGeo`

    - #### skipUpdateOnce

          public IBoidGeo skipUpdateOnce(boolean f)

      Description copied from class: `IParticleGeo`
      for other agent to control particle
      Specified by:
        `skipUpdateOnce` in interface `IParticleI`
      Overrides:
        `skipUpdateOnce` in class `IParticleGeo`

    - #### mass

          public IBoidGeo mass(double mass)

      Description copied from interface: `IParticleI`
      set mass
      Specified by:
        `mass` in interface `IParticleI`
      Overrides:
        `mass` in class `IParticleGeo`

    - #### position

          public IBoidGeo position(IVecI v)

      Description copied from interface: `IParticleI`
      set position
      Specified by:
        `position` in interface `IParticleI`
      Overrides:
        `position` in class `IParticleGeo`

    - #### pos

          public IBoidGeo pos(IVecI v)

      Description copied from interface: `IParticleI`
      set position
      Specified by:
        `pos` in interface `IParticleI`
      Overrides:
        `pos` in class `IParticleGeo`

    - #### velocity

          public IBoidGeo velocity(IVecI v)

      Description copied from interface: `IParticleI`
      set velocity
      Specified by:
        `velocity` in interface `IParticleI`
      Overrides:
        `velocity` in class `IParticleGeo`

    - #### vel

          public IBoidGeo vel(IVecI v)

      Description copied from interface: `IParticleI`
      set velocity
      Specified by:
        `vel` in interface `IParticleI`
      Overrides:
        `vel` in class `IParticleGeo`

    - #### force

          public IBoidGeo force(IVecI v)

      Description copied from interface: `IParticleI`
      set force
      Specified by:
        `force` in interface `IParticleI`
      Overrides:
        `force` in class `IParticleGeo`

    - #### frc

          public IBoidGeo frc(IVecI v)

      Description copied from interface: `IParticleI`
      set force
      Specified by:
        `frc` in interface `IParticleI`
      Overrides:
        `frc` in class `IParticleGeo`

    - #### friction

          public IBoidGeo friction(double friction)

      Description copied from interface: `IParticleI`
      set friction
      Specified by:
        `friction` in interface `IParticleI`
      Overrides:
        `friction` in class `IParticleGeo`

    - #### fric

          public IBoidGeo fric(double friction)

      Description copied from interface: `IParticleI`
      set friction
      Specified by:
        `fric` in interface `IParticleI`
      Overrides:
        `fric` in class `IParticleGeo`

    - #### decay

          public IBoidGeo decay(double d)

      Specified by:
        `decay` in interface `IParticleI`
      Overrides:
        `decay` in class `IParticleGeo`

    - #### push

          public IBoidGeo push(IVecI f)

      Description copied from class: `IParticleGeo`
      adding force
      Specified by:
        `push` in interface `IParticleI`
      Overrides:
        `push` in class `IParticleGeo`

    - #### push

          public IBoidGeo push(double fx,
                      double fy,
                      double fz)

      Description copied from class: `IParticleGeo`
      adding force
      Specified by:
        `push` in interface `IParticleI`
      Overrides:
        `push` in class `IParticleGeo`

    - #### pull

          public IBoidGeo pull(IVecI f)

      Description copied from class: `IParticleGeo`
      adding negative force
      Specified by:
        `pull` in interface `IParticleI`
      Overrides:
        `pull` in class `IParticleGeo`

    - #### pull

          public IBoidGeo pull(double fx,
                      double fy,
                      double fz)

      Description copied from class: `IParticleGeo`
      adding negative force
      Specified by:
        `pull` in interface `IParticleI`
      Overrides:
        `pull` in class `IParticleGeo`

    - #### addForce

          public IBoidGeo addForce(IVecI f)

      Description copied from class: `IParticleGeo`
      adding force (alias of push)
      Specified by:
        `addForce` in interface `IParticleI`
      Overrides:
        `addForce` in class `IParticleGeo`

    - #### addForce

          public IBoidGeo addForce(double fx,
                          double fy,
                          double fz)

      Description copied from class: `IParticleGeo`
      adding force (alias of push)
      Specified by:
        `addForce` in interface `IParticleI`
      Overrides:
        `addForce` in class `IParticleGeo`

    - #### reset

          public IBoidGeo reset()

      Description copied from class: `IParticleGeo`
      setting force zero
      Specified by:
        `reset` in interface `IParticleI`
      Overrides:
        `reset` in class `IParticleGeo`

    - #### resetForce

          public IBoidGeo resetForce()

      Description copied from class: `IParticleGeo`
      setting force zero (alias of reset())
      Specified by:
        `resetForce` in interface `IParticleI`
      Overrides:
        `resetForce` in class `IParticleGeo`

    - #### x

          public IBoidGeo x(double vx)

      methods of IVecI
      Specified by:
        `x` in interface `IVecI`
      Overrides:
        `x` in class `IParticleGeo`

    - #### y

          public IBoidGeo y(double vy)

      Description copied from interface: `IVecI`
      setting y component
      Specified by:
        `y` in interface `IVecI`
      Overrides:
        `y` in class `IParticleGeo`

    - #### z

          public IBoidGeo z(double vz)

      Description copied from interface: `IVecI`
      setting z component
      Specified by:
        `z` in interface `IVecI`
      Overrides:
        `z` in class `IParticleGeo`

    - #### x

          public IBoidGeo x(IDoubleI vx)

      Description copied from interface: `IVecI`
      setting x component
      Specified by:
        `x` in interface `IVecI`
      Overrides:
        `x` in class `IParticleGeo`

    - #### y

          public IBoidGeo y(IDoubleI vy)

      Description copied from interface: `IVecI`
      setting y component
      Specified by:
        `y` in interface `IVecI`
      Overrides:
        `y` in class `IParticleGeo`

    - #### z

          public IBoidGeo z(IDoubleI vz)

      Description copied from interface: `IVecI`
      setting z component
      Specified by:
        `z` in interface `IVecI`
      Overrides:
        `z` in class `IParticleGeo`

    - #### x

          public IBoidGeo x(IVecI v)

      setting x component by x component of input vector
      Specified by:
        `x` in interface `IVecI`
      Overrides:
        `x` in class `IParticleGeo`

    - #### y

          public IBoidGeo y(IVecI v)

      setting y component by y component of input vector
      Specified by:
        `y` in interface `IVecI`
      Overrides:
        `y` in class `IParticleGeo`

    - #### z

          public IBoidGeo z(IVecI v)

      setting z component by z component of input vector
      Specified by:
        `z` in interface `IVecI`
      Overrides:
        `z` in class `IParticleGeo`

    - #### x

          public IBoidGeo x(IVec2I v)

      setting x component by x component of input vector
      Specified by:
        `x` in interface `IVecI`
      Overrides:
        `x` in class `IParticleGeo`

    - #### y

          public IBoidGeo y(IVec2I v)

      setting y component by y component of input vector
      Specified by:
        `y` in interface `IVecI`
      Overrides:
        `y` in class `IParticleGeo`

    - #### dup

          public IBoidGeo dup()

      Description copied from interface: `ITransformable`
      duplicate the instance
      Specified by:
        `dup` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `dup` in interface `ITransformable`
      Specified by:
        `dup` in interface `IVecI`
      Overrides:
        `dup` in class `IParticleGeo`

    - #### set

          public IBoidGeo set(IVecI v)

      Specified by:
        `set` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `set` in interface `IVecI`
      Overrides:
        `set` in class `IParticleGeo`

    - #### set

          public IBoidGeo set(double x,
                     double y,
                     double z)

      Specified by:
        `set` in interface `IVecI`
      Overrides:
        `set` in class `IParticleGeo`

    - #### set

          public IBoidGeo set(IDoubleI x,
                     IDoubleI y,
                     IDoubleI z)

      Specified by:
        `set` in interface `IVecI`
      Overrides:
        `set` in class `IParticleGeo`

    - #### add

          public IBoidGeo add(double x,
                     double y,
                     double z)

      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IParticleGeo`

    - #### add

          public IBoidGeo add(IDoubleI x,
                     IDoubleI y,
                     IDoubleI z)

      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IParticleGeo`

    - #### add

          public IBoidGeo add(IVecI v)

      Specified by:
        `add` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IParticleGeo`

    - #### sub

          public IBoidGeo sub(double x,
                     double y,
                     double z)

      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in interface `IVecI`
      Overrides:
        `sub` in class `IParticleGeo`

    - #### sub

          public IBoidGeo sub(IDoubleI x,
                     IDoubleI y,
                     IDoubleI z)

      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in interface `IVecI`
      Overrides:
        `sub` in class `IParticleGeo`

    - #### sub

          public IBoidGeo sub(IVecI v)

      Specified by:
        `sub` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in interface `IVecI`
      Overrides:
        `sub` in class `IParticleGeo`

    - #### mul

          public IBoidGeo mul(IDoubleI v)

      Specified by:
        `mul` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `mul` in interface `ITransformable`
      Specified by:
        `mul` in interface `IVecI`
      Overrides:
        `mul` in class `IParticleGeo`

    - #### mul

          public IBoidGeo mul(double v)

      Specified by:
        `mul` in interface `ITransformable`
      Specified by:
        `mul` in interface `IVecI`
      Overrides:
        `mul` in class `IParticleGeo`

    - #### div

          public IBoidGeo div(IDoubleI v)

      Specified by:
        `div` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `div` in interface `ITransformable`
      Specified by:
        `div` in interface `IVecI`
      Overrides:
        `div` in class `IParticleGeo`

    - #### div

          public IBoidGeo div(double v)

      Specified by:
        `div` in interface `ITransformable`
      Specified by:
        `div` in interface `IVecI`
      Overrides:
        `div` in class `IParticleGeo`

    - #### neg

          public IBoidGeo neg()

      Specified by:
        `neg` in interface `ITransformable`
      Specified by:
        `neg` in interface `IVecI`
      Overrides:
        `neg` in class `IParticleGeo`

    - #### rev

          public IBoidGeo rev()

      Description copied from interface: `IVecI`
      alias of neg()
      Specified by:
        `rev` in interface `IVecI`
      Overrides:
        `rev` in class `IParticleGeo`

    - #### flip

          public IBoidGeo flip()

      Description copied from interface: `IVecI`
      alias of neg()
      Specified by:
        `flip` in interface `ITransformable`
      Specified by:
        `flip` in interface `IVecI`
      Overrides:
        `flip` in class `IParticleGeo`

    - #### zero

          public IBoidGeo zero()

      Description copied from interface: `IVecI`
      setting all zero
      Specified by:
        `zero` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `zero` in interface `IVecI`
      Overrides:
        `zero` in class `IParticleGeo`

    - #### add

          public IBoidGeo add(IVecI v,
                     double f)

      Description copied from interface: `IVecI`
      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IParticleGeo`

    - #### add

          public IBoidGeo add(IVecI v,
                     IDoubleI f)

      Description copied from interface: `IVecI`
      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IParticleGeo`

    - #### add

          public IBoidGeo add(double f,
                     IVecI v)

      Description copied from interface: `IVecI`
      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IParticleGeo`

    - #### add

          public IBoidGeo add(IDoubleI f,
                     IVecI v)

      Description copied from interface: `IVecI`
      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IParticleGeo`

    - #### len

          public IBoidGeo len(IDoubleI l)

      Description copied from interface: `IVecI`
      setting length
      Specified by:
        `len` in interface `IVecI`
      Overrides:
        `len` in class `IParticleGeo`

    - #### len

          public IBoidGeo len(double l)

      Description copied from interface: `IVecI`
      setting length
      Specified by:
        `len` in interface `IVecI`
      Overrides:
        `len` in class `IParticleGeo`

    - #### unit

          public IBoidGeo unit()

      Description copied from interface: `IVecI`
      unitize
      Specified by:
        `unit` in interface `IVecI`
      Overrides:
        `unit` in class `IParticleGeo`

    - #### rot

          public IBoidGeo rot(IDoubleI angle)

      Description copied from interface: `IVecI`
      rotation on XY plane
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IBoidGeo rot(double angle)

      Description copied from interface: `IVecI`
      rotation on XY plane
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IBoidGeo rot(IVecI axis,
                     IDoubleI angle)

      Description copied from interface: `IVecI`
      rotation around axis vector
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IBoidGeo rot(IVecI axis,
                     double angle)

      Description copied from interface: `IVecI`
      rotation around axis vector
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IBoidGeo rot(double axisX,
                     double axisY,
                     double axisZ,
                     double angle)

      Description copied from interface: `IVecI`
      rotation around axis vector
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IBoidGeo rot(IVecI center,
                     IVecI axis,
                     double angle)

      Description copied from interface: `IVecI`
      rotation around axis vector and center point
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IBoidGeo rot(IVecI center,
                     IVecI axis,
                     IDoubleI angle)

      Description copied from interface: `IVecI`
      rotation around axis vector and center point
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IBoidGeo rot(double centerX,
                     double centerY,
                     double centerZ,
                     double axisX,
                     double axisY,
                     double axisZ,
                     double angle)

      Description copied from interface: `IVecI`
      rotation around axis vector and center point
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IBoidGeo rot(IVecI axis,
                     IVecI destDir)

      Description copied from class: `IParticleGeo`
      Rotate to destination direction vector.
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IBoidGeo rot(IVecI center,
                     IVecI axis,
                     IVecI destPt)

      Description copied from class: `IParticleGeo`
      Rotate to destination point location.
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot2

          public IBoidGeo rot2(double angle)

      rotation on xy-plane; alias of rot(double)
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IParticleGeo`

    - #### rot2

          public IBoidGeo rot2(IDoubleI angle)

      rotation on xy-plane; alias of rot(IDoubleI)
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IParticleGeo`

    - #### rot2

          public IBoidGeo rot2(IVecI center,
                      double angle)

      rotation on xy-plane
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IParticleGeo`

    - #### rot2

          public IBoidGeo rot2(IVecI center,
                      IDoubleI angle)

      rotation on xy-plane
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IParticleGeo`

    - #### rot2

          public IBoidGeo rot2(double centerX,
                      double centerY,
                      double angle)

      rotation on xy-plane
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IParticleGeo`

    - #### rot2

          public IBoidGeo rot2(IVecI destDir)

      rotation on xy-plane towards destDir
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IParticleGeo`

    - #### rot2

          public IBoidGeo rot2(IVecI center,
                      IVecI destPt)

      rotation on xy-plane towards destPt
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IParticleGeo`

    - #### scale

          public IBoidGeo scale(IDoubleI f)

      Description copied from class: `IParticleGeo`
      alias of mul
      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in interface `IVecI`
      Overrides:
        `scale` in class `IParticleGeo`

    - #### scale

          public IBoidGeo scale(double f)

      Description copied from class: `IParticleGeo`
      alias of mul
      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in interface `IVecI`
      Overrides:
        `scale` in class `IParticleGeo`

    - #### scale

          public IBoidGeo scale(IVecI center,
                       IDoubleI f)

      Description copied from interface: `IVecI`
      scale from a center
      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in interface `IVecI`
      Overrides:
        `scale` in class `IParticleGeo`

    - #### scale

          public IBoidGeo scale(IVecI center,
                       double f)

      Description copied from interface: `IVecI`
      scale from a center
      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in interface `IVecI`
      Overrides:
        `scale` in class `IParticleGeo`

    - #### scale

          public IBoidGeo scale(double centerX,
                       double centerY,
                       double centerZ,
                       double f)

      Description copied from interface: `IVecI`
      scale from a center
      Specified by:
        `scale` in interface `IVecI`
      Overrides:
        `scale` in class `IParticleGeo`

    - #### scale1d

          public IBoidGeo scale1d(IVecI axis,
                         double f)

      scale only in 1 direction
      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IParticleGeo`

    - #### scale1d

          public IBoidGeo scale1d(IVecI axis,
                         IDoubleI f)

      Description copied from interface: `IVecI`
      scale only in 1 direction
      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IParticleGeo`

    - #### scale1d

          public IBoidGeo scale1d(double axisX,
                         double axisY,
                         double axisZ,
                         double f)

      Description copied from interface: `IVecI`
      scale only in 1 direction
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IParticleGeo`

    - #### scale1d

          public IBoidGeo scale1d(IVecI center,
                         IVecI axis,
                         double f)

      Description copied from interface: `IVecI`
      scale only in 1 direction from a center
      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IParticleGeo`

    - #### scale1d

          public IBoidGeo scale1d(IVecI center,
                         IVecI axis,
                         IDoubleI f)

      Description copied from interface: `IVecI`
      scale only in 1 direction from a center
      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IParticleGeo`

    - #### scale1d

          public IBoidGeo scale1d(double centerX,
                         double centerY,
                         double centerZ,
                         double axisX,
                         double axisY,
                         double axisZ,
                         double f)

      Description copied from interface: `IVecI`
      scale only in 1 direction from a center
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IParticleGeo`

    - #### ref

          public IBoidGeo ref(IVecI planeDir)

      Description copied from class: `IParticleGeo`
      reflect (mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `ref` in interface `ITransformable`
      Specified by:
        `ref` in interface `IVecI`
      Overrides:
        `ref` in class `IParticleGeo`

    - #### ref

          public IBoidGeo ref(double planeX,
                     double planeY,
                     double planeZ)

      Description copied from class: `IParticleGeo`
      reflect (mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `ref` in interface `IVecI`
      Overrides:
        `ref` in class `IParticleGeo`

    - #### ref

          public IBoidGeo ref(IVecI center,
                     IVecI planeDir)

      Description copied from class: `IParticleGeo`
      reflect (mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `ref` in interface `ITransformable`
      Specified by:
        `ref` in interface `IVecI`
      Overrides:
        `ref` in class `IParticleGeo`

    - #### ref

          public IBoidGeo ref(double centerX,
                     double centerY,
                     double centerZ,
                     double planeX,
                     double planeY,
                     double planeZ)

      Description copied from class: `IParticleGeo`
      reflect (mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `ref` in interface `IVecI`
      Overrides:
        `ref` in class `IParticleGeo`

    - #### mirror

          public IBoidGeo mirror(IVecI planeDir)

      Description copied from class: `IParticleGeo`
      reflect (mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `mirror` in interface `ITransformable`
      Specified by:
        `mirror` in interface `IVecI`
      Overrides:
        `mirror` in class `IParticleGeo`

    - #### mirror

          public IBoidGeo mirror(double planeX,
                        double planeY,
                        double planeZ)

      Description copied from class: `IParticleGeo`
      reflect (mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `mirror` in interface `IVecI`
      Overrides:
        `mirror` in class `IParticleGeo`

    - #### mirror

          public IBoidGeo mirror(IVecI center,
                        IVecI planeDir)

      Description copied from class: `IParticleGeo`
      reflect (mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `mirror` in interface `ITransformable`
      Specified by:
        `mirror` in interface `IVecI`
      Overrides:
        `mirror` in class `IParticleGeo`

    - #### mirror

          public IBoidGeo mirror(double centerX,
                        double centerY,
                        double centerZ,
                        double planeX,
                        double planeY,
                        double planeZ)

      Description copied from class: `IParticleGeo`
      reflect (mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `mirror` in interface `IVecI`
      Overrides:
        `mirror` in class `IParticleGeo`

    - #### shear

          public IBoidGeo shear(double sxy,
                       double syx,
                       double syz,
                       double szy,
                       double szx,
                       double sxz)

      Description copied from class: `IParticleGeo`
      shear operation
      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in interface `IVecI`
      Overrides:
        `shear` in class `IParticleGeo`

    - #### shear

          public IBoidGeo shear(IDoubleI sxy,
                       IDoubleI syx,
                       IDoubleI syz,
                       IDoubleI szy,
                       IDoubleI szx,
                       IDoubleI sxz)

      Description copied from interface: `IVecI`
      shear operation
      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in interface `IVecI`
      Overrides:
        `shear` in class `IParticleGeo`

    - #### shear

          public IBoidGeo shear(IVecI center,
                       double sxy,
                       double syx,
                       double syz,
                       double szy,
                       double szx,
                       double sxz)

      Description copied from interface: `IVecI`
      shear operation
      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in interface `IVecI`
      Overrides:
        `shear` in class `IParticleGeo`

    - #### shear

          public IBoidGeo shear(IVecI center,
                       IDoubleI sxy,
                       IDoubleI syx,
                       IDoubleI syz,
                       IDoubleI szy,
                       IDoubleI szx,
                       IDoubleI sxz)

      Description copied from interface: `IVecI`
      shear operation
      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in interface `IVecI`
      Overrides:
        `shear` in class `IParticleGeo`

    - #### shearXY

          public IBoidGeo shearXY(double sxy,
                         double syx)

      Description copied from interface: `IVecI`
      shear operation on XY
      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in interface `IVecI`
      Overrides:
        `shearXY` in class `IParticleGeo`

    - #### shearXY

          public IBoidGeo shearXY(IDoubleI sxy,
                         IDoubleI syx)

      Description copied from interface: `IVecI`
      shear operation on XY
      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in interface `IVecI`
      Overrides:
        `shearXY` in class `IParticleGeo`

    - #### shearXY

          public IBoidGeo shearXY(IVecI center,
                         double sxy,
                         double syx)

      Description copied from interface: `IVecI`
      shear operation on XY
      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in interface `IVecI`
      Overrides:
        `shearXY` in class `IParticleGeo`

    - #### shearXY

          public IBoidGeo shearXY(IVecI center,
                         IDoubleI sxy,
                         IDoubleI syx)

      Description copied from interface: `IVecI`
      shear operation on XY
      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in interface `IVecI`
      Overrides:
        `shearXY` in class `IParticleGeo`

    - #### shearYZ

          public IBoidGeo shearYZ(double syz,
                         double szy)

      Description copied from interface: `IVecI`
      shear operation on YZ
      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in interface `IVecI`
      Overrides:
        `shearYZ` in class `IParticleGeo`

    - #### shearYZ

          public IBoidGeo shearYZ(IDoubleI syz,
                         IDoubleI szy)

      Description copied from interface: `IVecI`
      shear operation on YZ
      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in interface `IVecI`
      Overrides:
        `shearYZ` in class `IParticleGeo`

    - #### shearYZ

          public IBoidGeo shearYZ(IVecI center,
                         double syz,
                         double szy)

      Description copied from interface: `IVecI`
      shear operation on YZ
      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in interface `IVecI`
      Overrides:
        `shearYZ` in class `IParticleGeo`

    - #### shearYZ

          public IBoidGeo shearYZ(IVecI center,
                         IDoubleI syz,
                         IDoubleI szy)

      Description copied from interface: `IVecI`
      shear operation on YZ
      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in interface `IVecI`
      Overrides:
        `shearYZ` in class `IParticleGeo`

    - #### shearZX

          public IBoidGeo shearZX(double szx,
                         double sxz)

      Description copied from interface: `IVecI`
      shear operation on ZX
      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in interface `IVecI`
      Overrides:
        `shearZX` in class `IParticleGeo`

    - #### shearZX

          public IBoidGeo shearZX(IDoubleI szx,
                         IDoubleI sxz)

      Description copied from interface: `IVecI`
      shear operation on ZX
      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in interface `IVecI`
      Overrides:
        `shearZX` in class `IParticleGeo`

    - #### shearZX

          public IBoidGeo shearZX(IVecI center,
                         double szx,
                         double sxz)

      Description copied from interface: `IVecI`
      shear operation on ZX
      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in interface `IVecI`
      Overrides:
        `shearZX` in class `IParticleGeo`

    - #### shearZX

          public IBoidGeo shearZX(IVecI center,
                         IDoubleI szx,
                         IDoubleI sxz)

      Description copied from interface: `IVecI`
      shear operation on ZX
      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in interface `IVecI`
      Overrides:
        `shearZX` in class `IParticleGeo`

    - #### translate

          public IBoidGeo translate(double x,
                           double y,
                           double z)

      Description copied from class: `IParticleGeo`
      translate is alias of add()
      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in interface `IVecI`
      Overrides:
        `translate` in class `IParticleGeo`

    - #### translate

          public IBoidGeo translate(IDoubleI x,
                           IDoubleI y,
                           IDoubleI z)

      Description copied from interface: `IVecI`
      alias of add()
      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in interface `IVecI`
      Overrides:
        `translate` in class `IParticleGeo`

    - #### translate

          public IBoidGeo translate(IVecI v)

      Description copied from interface: `IVecI`
      alias of add()
      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in interface `IVecI`
      Overrides:
        `translate` in class `IParticleGeo`

    - #### transform

          public IBoidGeo transform(IMatrix3I mat)

      Description copied from interface: `IVecI`
      transform with a transformation matrix
      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in interface `IVecI`
      Overrides:
        `transform` in class `IParticleGeo`

    - #### transform

          public IBoidGeo transform(IMatrix4I mat)

      Description copied from interface: `IVecI`
      transform with a transformation matrix
      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in interface `IVecI`
      Overrides:
        `transform` in class `IParticleGeo`

    - #### transform

          public IBoidGeo transform(IVecI xvec,
                           IVecI yvec,
                           IVecI zvec)

      Description copied from interface: `IVecI`
      transform with a transformation vectors
      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in interface `IVecI`
      Overrides:
        `transform` in class `IParticleGeo`

    - #### transform

          public IBoidGeo transform(IVecI xvec,
                           IVecI yvec,
                           IVecI zvec,
                           IVecI translate)

      Description copied from interface: `IVecI`
      transform with a transformation vectors
      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in interface `IVecI`
      Overrides:
        `transform` in class `IParticleGeo`

    - #### mv

          public IBoidGeo mv(double x,
                    double y,
                    double z)

      Description copied from class: `IParticleGeo`
      mv() is alias of add()
      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in interface `IVecI`
      Overrides:
        `mv` in class `IParticleGeo`

    - #### mv

          public IBoidGeo mv(IDoubleI x,
                    IDoubleI y,
                    IDoubleI z)

      Description copied from interface: `IVecI`
      mv() is alias of add()
      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in interface `IVecI`
      Overrides:
        `mv` in class `IParticleGeo`

    - #### mv

          public IBoidGeo mv(IVecI v)

      Description copied from interface: `IVecI`
      mv() is alias of add()
      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in interface `IVecI`
      Overrides:
        `mv` in class `IParticleGeo`

    - #### cp

          public IBoidGeo cp()

      Description copied from class: `IParticleGeo`
      cp() is alias of dup()
      Specified by:
        `cp` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in interface `IVecI`
      Overrides:
        `cp` in class `IParticleGeo`

    - #### cp

          public IBoidGeo cp(double x,
                    double y,
                    double z)

      Description copied from class: `IParticleGeo`
      cp() is alias of dup().add()
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in interface `IVecI`
      Overrides:
        `cp` in class `IParticleGeo`

    - #### cp

          public IBoidGeo cp(IDoubleI x,
                    IDoubleI y,
                    IDoubleI z)

      Description copied from interface: `IVecI`
      cp() is alias of dup().add()
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in interface `IVecI`
      Overrides:
        `cp` in class `IParticleGeo`

    - #### cp

          public IBoidGeo cp(IVecI v)

      Description copied from interface: `IVecI`
      cp() is alias of dup().add()
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in interface `IVecI`
      Overrides:
        `cp` in class `IParticleGeo`